///////////////////////////////////////////////////////////////////////////////
// AW7GameInfo
// By: Kamek (kamek@postalleague.com)
// For: AW7
//
// Since the AW game extends from P2GameInfoSingle and not GameSinglePlayer,
// we have to copy a bunch of crap.
///////////////////////////////////////////////////////////////////////////////
// AW7 addin mod Ig50
// By Ig50
//
// Thank you AW7 staffs.
///////////////////////////////////////////////////////////////////////////////
class Ig50GameInfo extends AW7EarlyGameInfo;

///////////////////////////////////////////////////////////////////////////////
// Config Vars
///////////////////////////////////////////////////////////////////////////////
var globalconfig int InitVal;
var globalconfig int CornHole;
var globalconfig int UberSquire;
var globalconfig int MetoolAlloy;
var globalconfig int BustaRhymes;
var globalconfig int UnFathomable;
var globalconfig int MatrixMan;

var globalconfig bool bNewWeaponOrder;	// splits up Group 1 melee weapons between 1 and 2, moves Group 2 weapons to Group 3
var globalconfig bool bDrawTime;

///////////////////////////////////////////////////////////////////////////////
// Consts
///////////////////////////////////////////////////////////////////////////////
const INIT_1 = 150;
const INIT_2 = 120;
const INIT_3 = 3;
const INIT_PATH = "AW7addinIG50Game.Ig50GameInfo InitVal";

const CORN_1 = 291;
const CORN_2 = 555;
const CORN_3 = 5.11;
const CORN_PATH = "AW7addinIG50Game.Ig50GameInfo CornHole";

const UBER_1 = 101;
const UBER_2 = 102;
const UBER_3 = 2;
const UBER_PATH = "AW7addinIG50Game.Ig50GameInfo UberSquire";

const METOOL_1 = 666;
const METOOL_2 = 911;
const METOOL_3 = 3.14;
const METOOL_PATH = "AW7addinIG50Game.Ig50GameInfo MetoolAlloy";

const BUSTA_1 = 222;
const BUSTA_2 = 333;
const BUSTA_3 = 1.214;
const BUSTA_PATH = "AW7addinIG50Game.Ig50GameInfo BustaRhymes";

const FATHOM_1 = 1000;
const FATHOM_2 = 1500;
const FATHOM_3 = 0.5;
const FATHOM_PATH = "AW7addinIG50Game.Ig50GameInfo UnFathomable";

const MATRIX_1 = 111;
const MATRIX_2 = 222;
const MATRIX_3 = 3.03;
const MATRIX_PATH = "AW7addinIG50Game.Ig50GameInfo MatrixMan";

///////////////////////////////////////////////////////////////////////////////
// Public Vars
///////////////////////////////////////////////////////////////////////////////
var() string WeekendStartURL;
var() class<AWCatPawn> ApocalypseCatClass;
var() class<AWGaryHead> GaryHeadClass;
var() class<ZombieHead> ZombieHeadClass;

///////////////////////////////////////////////////////////////////////////////
// Internal Vars
///////////////////////////////////////////////////////////////////////////////
var Material FireCorona;
var float NewCatTime;	// When we'll make a new cat
var float CatRainTime;	// When we'll start raining again
var bool bRainingCats;

///////////////////////////////////////////////////////////////////////////////
// More Consts
///////////////////////////////////////////////////////////////////////////////
const NEW_CAT_BASE_TIME	= 5;
const NEW_CAT_RAND_TIME	= 5;
const RAIN_BASE_TIME	= 60;
const RAIN_RAND_TIME	= 120;
const CAT_MAKE_RANGE_DIST=4000;
const CAT_MAKE_RANGE_XY = 1500;
const CAT_MAKE_BASE_DIST= 200;
const CAT_MAKE_Z		= 3000;
const CAT_RAIN_SPEED	= 100;
const CAT_RAIN_ACC		= -1200;

const DAY_FRIDAY = 4;
const DAY_SATURDAY = 5;

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool IsWeekend()
{
	return (TheGameState.CurrentDay >= DAY_SATURDAY);
}

/*
///////////////////////////////////////////////////////////////////////////////
// Hack
///////////////////////////////////////////////////////////////////////////////
function SearchForOldControllers()
{
	foreach DynamicActors(class'AWPerson', P)
		if (P.Controller.class == class'BystanderController')
			ConvertController(P);
}

function ConvertController(AWPerson P)
{
	P.Controller.Destroy();
	P.Controller = None;
	P.Controller = spawn(class'AW7CivilianController');
	if(P.Controller != None )
	{
		P.Controller.Possess(P);
		AIController(P.Controller).Skill += P.SkillModifier;
		P.CheckForAIScript();
	}
}
*/

function int ReduceDamage( int Damage, pawn injured, pawn instigatedBy, vector HitLocation, out vector Momentum, class<DamageType> DamageType )
{
	if (IsCinematic() && AW7PostalDude(Injured) != None)
		return 0;
	else
		return Super.ReduceDamage(Damage, Injured, InstigatedBy, HitLocation, Momentum, DamageType);
}

///////////////////////////////////////////////////////////////////////////////
// HACK -- switch weapons to shiny or non-shiny textures
///////////////////////////////////////////////////////////////////////////////
function HackMakeShiny()
{
	local MaDBloodWeapon W;
//	local P2WeaponPickup P;

	foreach DynamicActors(class'MaDBloodWeapon', W)
		W.MakeShiny();
}

///////////////////////////////////////////////////////////////////////////////
// HACK -- switch weapons to shiny or non-shiny textures
///////////////////////////////////////////////////////////////////////////////
function HackMakeUnShiny()
{
	local MaDBloodWeapon W;
//	local P2WeaponPickup P;

	foreach DynamicActors(class'MaDBloodWeapon', W)
		W.MakeUnShiny();
}

///////////////////////////////////////////////////////////////////////////////
// REALLY BAD HACK.
// The "proper" way is to subclass all these pawns. But I don't have the time...
///////////////////////////////////////////////////////////////////////////////
function HackChanger(class<AWPerson> PawnClass, bool bIsZombie, bool bIsGary)
{
	if (bIsZombie)
		PawnClass.Default.HeadClass = ZombieHeadClass;
	else if (bIsGary)
		PawnClass.Default.HeadClass = GaryHeadClass;
	else
		PawnClass.Default.HeadClass = class'AW7Person'.Default.HeadClass;

	if (!bIsGary)
		PawnClass.Default.LimbClass = class'AW7Person'.Default.LimbClass;

	PawnClass.Default.GutsEmitterClass1 = class'AW7Person'.Default.GutsEmitterClass1;
	PawnClass.Default.GutsEmitterClass2 = class'AW7Person'.Default.GutsEmitterClass2;
}

///////////////////////////////////////////////////////////////////////////////
// REALLY BAD HACK.
// The "proper" way is to subclass all these pawns. But I don't have the time...
///////////////////////////////////////////////////////////////////////////////
function HackChangeHeadLimbAndGutsClass()
{
	HackChanger(class'AWMilitary',false,false);
	HackChanger(class'AWGary',false,true);
	HackChanger(class'AWSuperGary',false,true);
	HackChanger(class'BattleDamageGary',false,true);
	HackChanger(class'AWZombie',true,false);
	HackChanger(class'AWZombieCharger',true,false);
	HackChanger(class'AWZombieNoCharge',true,false);
	HackChanger(class'AWZombieNoSpit',true,false);
	HackChanger(class'AWZombieSpitter',true,false);
	HackChanger(class'AWZombieSuperCharger',true,false);
	HackChanger(class'AWZombieSuperSpitter',true,false);
	HackChanger(class'AWZombieTom',true,false);
	HackChanger(class'AnimalProtestors',false,false);
	HackChanger(class'AWBystanders',false,false);
	HackChanger(class'AWFanatics',false,false);
	HackChanger(class'AWSuperFanatics',false,false);
	HackChanger(class'AWRednecks',false,false);
	HackChanger(class'AWScaredGary',false,false);
	HackChanger(class'InvisiGuard',false,false);
	HackChanger(class'PhraudHogslop',false,false);
	HackChanger(class'PublisherGuard',false,false);

	if (TheyHateMeMode())
	{
		HackChangePawnSpawners();
		class'AWMilitary'.default.ControllerClass = class'AW7CivilianController';
		class'PublisherGuard'.default.ControllerClass = class'AW7CivilianController';
	}
}

function HackChangePawnSpawners()
{
	local PawnSpawner P;
	
	foreach DynamicActors(class'PawnSpawner', P)
		if (P.InitControllerClass == class'AWMilitaryController')
			P.InitControllerClass = class'AW7CivilianController';
}

///////////////////////////////////////////////////////////////////////////////
// Hacky, but could be worse...
///////////////////////////////////////////////////////////////////////////////
function SetWeaponOrder()
{
	const MachetePath = "AWInventory.MacheteWeapon";
	const ScythePath = "AWInventory.ScytheWeapon";
	const MeatcleaverPath = "AW7Inventory.MeatcleaverWeapon";
	const PitchforkPath = "AW7Inventory.PitchforkWeapon";
	const KatanaPath = "AW7Inventory.KatanaWeapon";
	const MaDBAxePath = "AW7MaDInventory.MaDBAxeWeapon";
	const MaDLAxePath = "AW7MaDInventory.MaDLAxeWeapon";
	const PistolPath = "Inventory.PistolWeapon";
	const MaDSPistolPath = "AW7MadInventory.MaDSPistolWeapon";
	const MaDColtPath = "AW7MaDInventory.MaDColtWeapon";
	const ShotgunPath = "Inventory.ShotgunWeapon";
	const SMEGPath = "AW7Inventory.SMGEWeapon";

	// Reorder various melee weapons. Also a hack, but unavoidable.
	class'MacheteWeapon'.Default.GroupOffset = 50;
	class'ScytheWeapon'.Default.GroupOffset = 51;

	if (bNewWeaponOrder)
	{
		Level.ConsoleCommand("set"@MachetePath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@ScythePath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MeatcleaverPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@PitchforkPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@KatanaPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDBAxePath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDLAxePath@"InventoryGroup 2");

		Level.ConsoleCommand("set"@PistolPath@"InventoryGroup 3");
		Level.ConsoleCommand("set"@MaDSPistolPath@"InventoryGroup 3");
		Level.ConsoleCommand("set"@MaDColtPath@"InventoryGroup 3");

		Level.ConsoleCommand("set"@ShotgunPath@"GroupOffset 4");
		Level.ConsoleCommand("set"@SMEGPath@"GroupOffset 5");
	}
	else
	{
		Level.ConsoleCommand("set"@MachetePath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@ScythePath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@MeatcleaverPath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@PitchforkPath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@KatanaPath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@MaDBAxePath@"InventoryGroup 1");
		Level.ConsoleCommand("set"@MaDLAxePath@"InventoryGroup 1");

		Level.ConsoleCommand("set"@PistolPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDSPistolPath@"InventoryGroup 2");
		Level.ConsoleCommand("set"@MaDColtPath@"InventoryGroup 2");

		Level.ConsoleCommand("set"@ShotgunPath@"GroupOffset 1");
		Level.ConsoleCommand("set"@SMEGPath@"GroupOffset 2");
	}
	
	if (bShinyWeapons)
		HackMakeShiny();
	else
		HackMakeUnShiny();
}

///////////////////////////////////////////////////////////////////////////////
// Destroy weapons we don't use anymore (Basey, Pitchfork, etc)
///////////////////////////////////////////////////////////////////////////////
function DestroyUnusedWeapons()
{
	local P2WeaponPickup Pick;
	
	foreach DynamicActors(class'P2WeaponPickup', Pick)
	{
		if (Pick.Class == class'MaDBaseyPickup'			// Spiked bat
			|| Pick.Class == class'PitchforkPickup'		// Pitchfork
			|| Pick.Class == class'MaDHammerPickup'		// Warhammer
			|| Pick.Class == class'MadMacePickup'		// Chaos Mace
			|| Pick.Class == class'DustersPickup')		// Dusters
			if (!Pick.bForTransferOnly) // only if it's not for transfer
				Pick.Destroy();
	}
}

///////////////////////////////////////////////////////////////////////////////
// This function is called before any other scripts (including PreBeginPlay().
///////////////////////////////////////////////////////////////////////////////
event InitGame(out string Options, out string Error)
{
	Super.InitGame(Options, Error);
	MySlotInfoMgr = spawn(class'AW7SlotInfoMgr');

	HackChangeHeadLimbAndGutsClass();
	SetWeaponOrder();
	DestroyUnusedWeapons();

	// Raise lifespan of gas trail. Also a hack.
	class'GasTrail'.Default.LifeSpan = 160;

	// Attempted crash fix DeadBodyMarker. Doesn't seem to work well.
	class'DeadBodyMarker'.Default.NotifyTime = 2.5;

	// This didn't work, so stubbed
//	class'FireEmitter'.Default.LightBrightness = 50;
//	class'FireEmitter'.Default.LightHue = 255;
//	class'FireEmitter'.Default.LightSaturation = 127;
//	class'FireEmitter'.Default.LightType = LT_Flicker;
//	class'FireEmitter'.Default.bDynamicLight = True;
//	class'FireEmitter'.Default.DrawScale = 0.5;
//	class'FireEmitter'.Default.bCorona = True;
//	class'FireEmitter'.Default.Skins[0] = FireCorona;
}

///////////////////////////////////////////////////////////////////////////////
// Check to swap out the postal dude's bandaged head skin.
///////////////////////////////////////////////////////////////////////////////
function CheckDudeHeadskin()
{
	local AW7PostalDude TheDude;

	foreach DynamicActors(class'AW7PostalDude', TheDude)
		TheDude.DudeCheckHeadSkin();
}

///////////////////////////////////////////////////////////////////////////////
// As soon as we have a valid game state, check for the dude's bandaged head
///////////////////////////////////////////////////////////////////////////////
event PostTravel(P2Pawn PlayerPawn)
{
	Super.PostTravel(PlayerPawn);
	CheckDudeHeadSkin();
}

///////////////////////////////////////////////////////////////////////////////
// As soon as we have a valid game state, check for the dude's bandaged head
///////////////////////////////////////////////////////////////////////////////
event PostLoadGame()
{
	Super.PostLoadGame();
	CheckDudeHeadSkin();
}

///////////////////////////////////////////////////////////////////////////////
// Add a controller to our newly spawned cat
///////////////////////////////////////////////////////////////////////////////
function AddController(FPSPawn newcat)
{
	if ( newcat.Controller == None
		&& newcat.Health > 0 )
	{
		if ( (newcat.ControllerClass != None))
			newcat.Controller = spawn(newcat.ControllerClass);
		if ( newcat.Controller != None )
			newcat.Controller.Possess(newcat);
		// Check for AI Script
		newcat.CheckForAIScript();
	}
}

///////////////////////////////////////////////////////////////////////////////
// Make sure it's the final day and all of our errands are done.
// *Doesn't* check to make sure it's not the demo.
///////////////////////////////////////////////////////////////////////////////
function bool AfterFinalErrand()
{
	// Last day of the real game and you're done with your errands
	return ((TheGameState.CurrentDay == DAY_FRIDAY)
			&& TheGameState.ErrandsCompletedToday >= Days[TheGameState.CurrentDay].NumActiveErrands());
}

///////////////////////////////////////////////////////////////////////////////
// Send player to the AW intro movie
///////////////////////////////////////////////////////////////////////////////
function StartWeekend(PlayerController Player)
{
	bShowDayDuringLoad = True;
	SendPlayerTo(Player, WeekendStartURL);
}

///////////////////////////////////////////////////////////////////////////////
// Send player to the next day
///////////////////////////////////////////////////////////////////////////////
function SendPlayerToNextDay(PlayerController player)
{
	// See if there's any more days
	if (TheGameState.CurrentDay + 1 < Days.length)
	{
		TheGameState.bChangeDayPostTravel = true;
		TheGameState.NextDay = TheGameState.CurrentDay + 1;
//		log(self@"SendPlayerToNextDay: Next day is"@TheGameState.NextDay);
		if (TheGameState.NextDay == DAY_SATURDAY)
			SendPlayerTo(Player, WeekendStartURL);
		else
			SendPlayerTo(player, StartNextDayURL);
	}
	else
	{
		// This shouldn't happen because the end-of-game movie
		// should end up calling EndOfGame() instead.  If it does
		// happen we'll treat it like a quit.
		QuitGame();
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
static final function string Lower(coerce string Text) {

  local int IndexChar;

  for (IndexChar = 0; IndexChar < Len(Text); IndexChar++)
    if (Mid(Text, IndexChar, 1) >= "A" &&
        Mid(Text, IndexChar, 1) <= "Z")
      Text = Left(Text, IndexChar) $ Chr(Asc(Mid(Text, IndexChar, 1)) + 32) $ Mid(Text, IndexChar + 1);

  return Text;
  }

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function string ParseLevelName(string In)
{
	local string S;

	S = Super.ParseLevelName(In);

	if (Right(S,4) ~= ".FUK")
		S = Left(S, Len(S)-4);

	return Lower(S);
}
/*
///////////////////////////////////////////////////////////////////////////////
// Check to remove this pickup from the GottenPickups list.
///////////////////////////////////////////////////////////////////////////////
function FindInPickupList(Pickup DelMe, String Lname)
{
	local int i;

	log(self@"searching for gotten pickup"@DelMe.Name@"from level"@LName);
	for(i=0; i<TheGameState.GottenPickups.Length; i++)
	{
		log(self$" checking"@TheGameState.GottenPickups[i].PickupName@"from level"@TheGameState.GottenPickups[i].LevelName);
		log(self@TheGameState.GottenPickups[i].PickupName@"=="@DelMe.Name$":"@string(TheGameState.GottenPickups[i].PickupName == DelMe.name));
		log(self@TheGameState.GottenPickups[i].LevelName@"~="@LName$":"@string(TheGameState.GottenPickups[i].LevelName ~= LName));
		if(TheGameState.GottenPickups[i].PickupName == DelMe.name
			&& TheGameState.GottenPickups[i].LevelName ~= Lname)
		{
			log(self$"												Removing "$DelMe);
			DelMe.Destroy();
			DelMe = None;
			break;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
//
// Go through all the pickups in the level, and remove any that have been
// previously taken by the dude.
//
///////////////////////////////////////////////////////////////////////////////
function RemoveGottenPickups()
{
	local Pickup CheckP, DelMe;
	local String Lname;

	Lname = ParseLevelName(Level.GetLocalURL());

	log(self$" RemoveGottenPickups for level"@Lname$", gottenpickups length "$TheGameState.GottenPickups.Length);

	foreach AllActors(class'Pickup', CheckP)
	{
		DelMe = CheckP;
//		log(self$" RemoveGottenPickups "$DelMe);
		// If you're not allowed to be recorded, you're not allowed to be restored
		if((P2WeaponPickup(DelMe) != None
				&& P2WeaponPickup(DelMe).bRecordAfterPickup)
			|| (P2PowerupPickup(DelMe) != None
					&& P2PowerupPickup(DelMe).bRecordAfterPickup)
			|| (P2AmmoPickup(DelMe) != None
					&& P2AmmoPickup(DelMe).bRecordAfterPickup))
		{
			FindInPickupList(DelMe, Lname);
		}
	}
}
*/
///////////////////////////////////////////////////////////////////////////////
// Rounds float X to DecimalPlaces places.
///////////////////////////////////////////////////////////////////////////////
static final function float Round(float X, int DecimalPlaces)
{
	local float Y;
	local int Z;

//	log("Round" @ X @ "to" @ DecimalPlaces @ "decimal places");
	Y = X * (10^DecimalPlaces);
	Z = Int(Y);
	Y = float(Z) / (10^DecimalPlaces);
//	log("Result is" @ Y);

	return Y;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function int GetRefVal(float Ref, float Parm1, float Parm2, float Parm3)
{
	local int Y;

	Y = Int((Ref + Parm1) * Parm2 / (Ref ^ Parm3));
	return Y;
}

///////////////////////////////////////////////////////////////////////////////
// Make sure these are done at StartGame and every time you load, in case,
// in between, someone deletes their ini, but uses an old load
///////////////////////////////////////////////////////////////////////////////
function PrepIniStartVals()
{
	GameRefVal = int(ConsoleCommand("get "@RefPath));

	if(GameRefVal == START_GAME_REF)
	{
		// Setup the reference value
		GameRefVal=(Rand(REF_STARTUP)/2);
		GameRefVal=2*GameRefVal;
		ConsoleCommand("set "@RefPath@GameRefVal);
//		log(self$" NEW made up gameref "$GameRefVal);

		InitVal = GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3);
		SaveVals(InitVal);
	}
	else
//		log(self$" CURRENT gameref "$GameRefVal);

	if(CoolStart == 0)
	{
		CoolStart = Rand(COOL_FACTOR);
		ConsoleCommand("set "@CoolStartPath@CoolStart);
	}

	if (InitVal != GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3))
	{
//		log(self@"Invalid InitVal ("$InitVal$") -- resetting");
		ZeroAllCheats();
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function SaveVals(
	optional int NewInit,
	optional int NewCorn,
	optional int NewUber,
	optional int NewMetool,
	optional int NewBusta,
	optional int NewFathom,
	optional int NewMatrix)
{

	if (NewInit != 0)
	{
		InitVal = NewInit;
//		log (self@"NEW InitVal --"@InitVal);
	    ConsoleCommand("set "@INIT_PATH@InitVal);
    }

	if (NewCorn != 0)
	{
		CornHole = NewCorn;
//		log (self@"NEW CornHole -- "@CornHole);
	    ConsoleCommand("set "@CORN_PATH@CornHole);
	}

	if (NewUber != 0)
	{
		UberSquire = NewUber;
//		log (self@"NEW UberSquire --"@UberSquire);
	    ConsoleCommand("set "@UBER_PATH@UberSquire);
	}

	if (NewMetool != 0)
	{
		MetoolAlloy = NewMetool;
//		log (self@"NEW Metool --"@MetoolAlloy);
	    ConsoleCommand("set "@METOOL_PATH@MetoolAlloy);
	}

	if (NewBusta != 0)
	{
		BustaRhymes = NewBusta;
//		log (self@"NEW Busta --"@BustaRhymes);
	    ConsoleCommand("set "@BUSTA_PATH@BustaRhymes);
	}

	if (NewFathom != 0)
	{
		UnFathomable = NewFathom;
//		log (self@"NEW UnFathomable --"@UnFathomable);
	    ConsoleCommand("set "@FATHOM_PATH@UnFathomable);
	}

	if (NewMatrix != 0)
	{
		MatrixMan = NewMatrix;
//		log (self@"NEW Matrix --"@MatrixMan);
	    ConsoleCommand("set "@MATRIX_PATH@MatrixMan);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function ZeroAllCheats()
{
	InitVal = GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3);
	SaveVals(InitVal, -1, -1, -1, -1, -1, -1);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableAllCheats()
{
	InitVal = GetRefVal(GameRefVal, INIT_1, INIT_2, INIT_3);
	SaveVals(
		InitVal,
		GetRefVal(InitVal, CORN_1, CORN_2, CORN_3),
		GetRefVal(InitVal, UBER_1, UBER_2, UBER_3),
		GetRefVal(InitVal, METOOL_1, METOOL_2, METOOL_3),
		GetRefVal(InitVal, BUSTA_1, BUSTA_2, BUSTA_3),
		GetRefVal(InitVal, FATHOM_1, FATHOM_2, FATHOM_3),
		GetRefVal(InitVal, MATRIX_1, MATRIX_2, MATRIX_3)
	);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableMetool()
{
	SaveVals(,,, GetRefVal(InitVal, METOOL_1, METOOL_2, METOOL_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableBusta()
{
	SaveVals(,,,, GetRefVal(InitVal, BUSTA_1, BUSTA_2, BUSTA_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableFathom()
{
	SaveVals(,,,,, GetRefVal(InitVal, FATHOM_1, FATHOM_2, FATHOM_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableMatrix()
{
	SaveVals(,,,,,, GetRefVal(InitVal, MATRIX_1, MATRIX_2, MATRIX_3));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool SissyEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, UBER_1, UBER_2, UBER_3);
//	log(self@"CheckSissy: UberSquire ="@UberSquire@"Must match"@ref);
	if (UberSquire == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@UBER_PATH));
//		log(self@"CheckSissy Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool MatrixEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, MATRIX_1, MATRIX_2, MATRIX_3);
//	log(self@"CheckMatrix: MatrixMan ="@MatrixMan@"Must match"@ref);
	if (MatrixMan == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@MATRIX_PATH));
//		log(self@"CheckMatrix Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool MetoolEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Metool_1, Metool_2, Metool_3);
//	log(self@"CheckMetool: MetoolAlloy ="@MetoolAlloy@"Must match"@ref);
	if (MetoolAlloy == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Metool_PATH));
//		log(self@"CheckMetool Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool BustaEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Busta_1, Busta_2, Busta_3);
//	log(self@"CheckBusta: BustaRhymes ="@BustaRhymes@"Must match"@ref);
	if (BustaRhymes == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Busta_PATH));
//		log(self@"CheckBusta Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool FathomEnabled()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Fathom_1, Fathom_2, Fathom_3);
//	log(self@"CheckFathom: UnFathomable ="@UnFathomable@"Must match"@ref);
	if (UnFathomable == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Fathom_PATH));
//		log(self@"CheckFathom Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool AllEnabled()
{
	return (
		FinallyOver() &&
		MatrixEnabled() &&
		MetoolEnabled() &&
		BustaEnabled() &&
		FathomEnabled()
		);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function EnableSissy()
{
	UberSquire = GetRefVal(InitVal, UBER_1, UBER_2, UBER_3);
	SaveVals(,,UberSquire);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function DisableSissy()
{
	SaveVals(,,-1);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function RecordEnding()
{
//	FOver = FOVER_SUM - GameRefVal;
//	TimesBeatenGame++;
//	ConsoleCommand("set "@FOverPath@FOver);
//	ConsoleCommand("set "@TimesBeatenGamePath@TimesBeatenGame);
	Super.RecordEnding();

	CornHole = GetRefVal(InitVal, CORN_1, CORN_2, CORN_3);
	SaveVals(,CornHole);
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
function bool FinallyOver()
{
	local int Ref;
	local int OldVal;

    ref = GetRefVal(InitVal, Corn_1, Corn_2, Corn_3);
//	log(self@"CheckCorn: CornHole ="@CornHole@"Must match"@ref);
	if (CornHole == Ref)
		return true;
	else
	{
		OldVal = Int(ConsoleCommand("get"@Corn_PATH));
//		log(self@"CheckFOver Take 2: OldVal ="@OldVal@"Must match"@ref);
		return (OldVal == Ref);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Reach into entry and put a new reference to every chameleon texture/meshes in this
// level.
///////////////////////////////////////////////////////////////////////////////
function StoreChams()
{
	local LevelInfo lev;
	local TextureLoader texl;
	local MeshLoader mesher;
	local Actor checkme;
	local PersonPawn checkpawn;

	lev = GetPlayer().GetEntryLevel();

//	log(self$" StoreChams "$lev);

	foreach lev.AllActors(class'Actor', checkme)
	{
		if(TextureLoader(checkme) != None)
			texl = TextureLoader(checkme);
		else if(MeshLoader(checkme) != None)
			mesher = MeshLoader(checkme);
	}

//	log(self$" checking texture loader "$mesher$" mesh loader "$mesher);
	if(texl != None
		&& mesher != None)
	{
		// Clear the lists
		texl.ClearArray();
		mesher.ClearArray();
		// Now go through each pawn and put their textures/meshes into the list
		foreach DynamicActors(class'PersonPawn', checkpawn)
		{
			texl.AddTexture(checkpawn.Skins[0]);
			mesher.AddMesh(checkpawn.Mesh);
			if(checkpawn.MyHead != None)
			{
				texl.AddTexture(checkpawn.MyHead.Skins[0]);
				mesher.AddMesh(checkpawn.MyHead.Mesh);
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
// Check to rain cats during the apocalypse
///////////////////////////////////////////////////////////////////////////////
function CheckCatRain(float DeltaTime)
{
	local P2Player p2p;
//	local CatRocket catr;
	local AWCatPawn catr;
	local vector dir, StartLoc;
	local float tempf;

	CatRainTime -= DeltaTime;

	// Check to toggle rain
	if(CatRainTime <= 0)
	{
		bRainingCats = !bRainingCats;
		if(bRainingCats)
			CatRainTime = RAIN_BASE_TIME + Rand(RAIN_RAND_TIME);
		else
			CatRainTime = Rand(RAIN_BASE_TIME);
	}

	if(bRainingCats)
	{
		NewCatTime -= DeltaTime;
		if(NewCatTime <= 0)
		{
			p2p = GetPlayer();
			if(p2p != None
				&& p2p.MyPawn != None)
			{
				NewCatTime = NEW_CAT_BASE_TIME + Rand(NEW_CAT_RAND_TIME);
				// Make it generally in front of the player
				// Move it in front of him
				StartLoc = vector(p2p.MyPawn.Rotation);
				StartLoc.z = 0;
				StartLoc = (FRand()*CAT_MAKE_RANGE_DIST + CAT_MAKE_BASE_DIST) * StartLoc;
				// Vaguely center the rain if he's dead
				if(p2p.MyPawn.Health <= 0)
				{
					tempf = 0.5*(CAT_MAKE_RANGE_DIST + CAT_MAKE_BASE_DIST);
					StartLoc.x += tempf;
					StartLoc.y += tempf;
				}
				// Now create a range around that point
				tempf = (0.5*CAT_MAKE_RANGE_XY);
				StartLoc.x = StartLoc.x + (FRand()*CAT_MAKE_RANGE_XY - tempf);
				StartLoc.y = StartLoc.y + (FRand()*CAT_MAKE_RANGE_XY - tempf);
				// Move it above him
				StartLoc.z += CAT_MAKE_Z;
				StartLoc = StartLoc + p2p.MyPawn.Location;
				dir = VRand();
				dir.z=-1;
//				catr = spawn(class'CatRocket',,,StartLoc,Rotator(dir));
				catr = spawn(ApocalypseCatClass,,, StartLoc, Rotator(Dir));
				if(catr != None)
				{
					AddController(CatR);
					catr.AmbientGlow=255;	// make them pulse so they're easier to see.
					// modify speed for a gentle rain
					Dir = vector(catr.Rotation);
					catr.Velocity = CAT_RAIN_SPEED * Dir;
					catr.Acceleration.z = CAT_RAIN_ACC;
				}
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Monitor things in the game, and rain cats
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
state RunningApocalypse
{
	function BeginState()
	{
		Super.BeginState();
		// Init new cat time, the first time the level starts
		NewCatTime = NEW_CAT_BASE_TIME + Rand(NEW_CAT_RAND_TIME);
	}
}

///////////////////////////////////////////////////////////////////////////////
// Copied from AWGameSPFinal, since we extend from AWGameSP and not
// AWGameSPFinal
///////////////////////////////////////////////////////////////////////////////
function bool PickupQuery( Pawn Other, Pickup item )
{
	if(P2WeaponPickup(item) == None
		|| AWDude(Other) == None
		|| AWDude(Other).GaryHeads <= 0
		|| AWDudePlayer(AWDude(Other).Controller).bNeverSwitchOnPickup)	// This variable gets stored and
		// switched to true on creation of a gary head, but if the user goes into the
		// options and switches it manually back and forth, it will come undone. We don't
		// want them doing this, so if they do, don't let them pick up the gun at all.
		// It'll all be back to normal when the heads are gone anyway.
		return Super.PickupQuery(Other, item);
	else
		return false;
}

///////////////////////////////////////////////////////////////////////////////
// Keep track of time elapsed for speed runs and whatnot
///////////////////////////////////////////////////////////////////////////////
event Tick(float Delta)
{
	local P2Player p2p;

	Super.Tick(Delta);

	p2p = GetPlayer();

	if(p2p != None
		&& p2p.Pawn != None
		&& p2p.Pawn.Health > 0
		&& p2p.Level.Pauser == None
		&& TheGameState != None)
		AW7GameState(TheGameState).TimeElapsed += Delta;
}

///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     WeekendStartURL="AW7_WeekendIntro.fuk"
     ApocalypseCatClass=Class'AW7Game.DervishCatR'
     GaryHeadClass=Class'AW7Inventory.AW7GaryHead'
     ZombieHeadClass=Class'AW7Inventory.AW7ZombieHead'
     FireCorona=Texture'PB_textures.Special.PB_flare_1'
     GameStateClass=Class'AW7Inventory.AW7GameState'
     Begin Object Class=DayBase Name=DayBase0
         Description="Monday"
         UniqueName="7DAYA"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day1"
         NewsTex="p2misc.newspaper_day_1"
         DudeNewsComment="DudeDialog.dude_news_monday"
         LoadTex="p2misc_full.loading1"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'AW7Game.ErrandBase0'
         Errands(1)=ErrandBase'AW7Game.ErrandBase1'
         Errands(2)=ErrandBase'AW7Game.ErrandBase2'
         Errands(3)=ErrandBase'AW7Game.ErrandBase_DeliverMotherboard'
         PlayerInvList(0)=(InvClassName="Inventory.MoneyInv",NeededAmount=20)
         PlayerInvList(1)=(InvClassName="Inventory.MapInv")
         PlayerInvList(2)=(InvClassName="Inventory.HandsWeapon")
         PlayerInvList(3)=(InvClassName="AW7Inventory.KarmaGun")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MilkInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.PaycheckInv")
         TakeFromPlayerList(5)=(InvClassName="AW7Inventory.MotherboardInv")
         Name="DayBase0"
     End Object
     Days(0)=DayBase'AW7addinIG50Game.DayBase0'
     Begin Object Class=DayBase Name=DayBase1
         Description="Tuesday"
         UniqueName="7DAYB"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day2"
         NewsTex="p2misc_full.newspaper_day_2"
         DudeNewsComment="DudeDialog.dude_news_tuesday"
         LoadTex="p2misc_full.loading2"
         DudeStartComment="DudeDialog.dude_map_exit2"
         Errands(0)=ErrandBase'AW7Game.ErrandBase3'
         Errands(1)=ErrandBase'AW7Game.ErrandBase4'
         Errands(2)=ErrandBase'AW7Game.ErrandBase5'
         Errands(3)=ErrandBase'AW7Game.ErrandBase6'
         PlayerInvList(0)=(InvClassName="Inventory.LibraryBookInv")
         PlayerInvList(1)=(InvClassName="Inventory.ClipboardWeapon")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.ClipboardWeapon")
         TakeFromPlayerList(4)=(InvClassName="Inventory.LibraryBookInv")
         Name="DayBase1"
     End Object
     Days(1)=DayBase'AW7addinIG50Game.DayBase1'
     Begin Object Class=DayBase Name=DayBase2
         Description="Wednesday"
         UniqueName="7DAYC"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day3"
         NewsTex="p2misc_full.newspaper_day_3"
         DudeNewsComment="DudeDialog.dude_news_wednesday"
         LoadTex="p2misc_full.loading3"
         DudeStartComment="DudeDialog.dude_map_exit3"
         Errands(0)=ErrandBase'AW7Game.ErrandBase7'
         Errands(1)=ErrandBase'AW7Game.ErrandBase8'
         Errands(2)=ErrandBase'AW7Game.ErrandBase9'
         Errands(3)=ErrandBase'AW7Game.ErrandBase10'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.TreeInv")
         Name="DayBase2"
     End Object
     Days(2)=DayBase'AW7addinIG50Game.DayBase2'
     Begin Object Class=DayBase Name=DayBase3
         Description="Thursday"
         UniqueName="7DAYD"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day4"
         NewsTex="p2misc_full.newspaper_day_4"
         DudeNewsComment="DudeDialog.dude_news_thursday"
         LoadTex="p2misc_full.loading4"
         DudeStartComment="DudeDialog.dude_map_exit4"
         Errands(0)=ErrandBase'AW7Game.ErrandBase11'
         Errands(1)=ErrandBase'AW7Game.ErrandBase12'
         Errands(2)=ErrandBase'AW7Game.ErrandBase13'
         Errands(3)=ErrandBase'AW7Game.ErrandBase14'
         PlayerInvList(0)=(InvClassName="Inventory.CitationInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.KrotchyInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.SteakInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.CitationInv")
         Name="DayBase3"
     End Object
     Days(3)=DayBase'AW7addinIG50Game.DayBase3'
     Begin Object Class=DayBase Name=DayBase4
         Description="Friday"
         UniqueName="7DAYE"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day5"
         NewsTex="p2misc_full.newspaper_day_5"
         DudeNewsComment="DudeDialog.dude_news_friday"
         LoadTex="p2misc_full.loading5"
         DudeStartComment="DudeDialog.dude_map_exit5"
         Errands(0)=ErrandBase'AW7Game.ErrandBase15'
         Errands(1)=ErrandBase'AW7Game.ErrandBase16'
         Errands(2)=ErrandBase'AW7Game.ErrandBase17'
         Errands(3)=ErrandBase'AW7Game.ErrandBase18'
         PlayerInvList(0)=(InvClassName="Inventory.GiftInv")
         PlayerInvList(1)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.ParcelInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.AlternatorInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.PillsInv")
         TakeFromPlayerList(6)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(7)=(InvClassName="Inventory.MapInv")
         TakeFromPlayerList(8)=(InvClassName="Inventory.GiftInv")
         Name="DayBase4"
     End Object
     Days(4)=DayBase'AW7addinIG50Game.DayBase4'
     Begin Object Class=DayBase Name=DayBase8
         Description="Saturday"
         UniqueName="DAY_A"
         ExcludeDays(0)="DEMO"
         LoadTex="aw_textures.loading_sat"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'AWGame.ErrandBase0'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
         Name="DayBase8"
     End Object
     Days(5)=DayBase'AW7addinIG50Game.DayBase8'
     Begin Object Class=DayBase Name=DayBase9
         Description="Sunday"
         UniqueName="DAY_B"
         ExcludeDays(0)="DEMO"
         LoadTex="aw_textures.loading_sun"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'AWGame.ErrandBase1'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
         Name="DayBase9"
     End Object
     Days(6)=DayBase'AW7addinIG50Game.DayBase9'
     IntroURL="AW7_Intro.fuk"
     StartFirstDayURL="AW7_Suburbs-3.fuk"
     StartNextDayURL="AW7_Suburbs-3.fuk"
     FinishedDayURL="AW7_HomeAtNight.fuk"
     JailURL="AW7_Police.fuk#cell"
     ApocalypseTex="AW7Tex.Misc.ApocalypseNewspaper"
     MainMenuURL="AW7_Startup.fuk"
     ChameleonClass=Class'AW7Game.AW7Chameleon'
     MatSwaps(0)=(OrigMat=Texture'Josh-textures.signs.game_banner_2',NewMat=Texture'Josh-textures.signs.game_banner_5')
     MatSwaps(1)=(OrigMat=Texture'Timb.arcade.Game_FagHunter',NewMat=Texture'Timb.arcade.Game_BastardFish')
     DefaultPlayerClassName="AW7Pawns.AW7PostalDude"
     HUDType="AW7Game.AW7HUD"
     GameName="Apocalypse Weekend 7-day Game"
     PlayerControllerClassName="AW7addinIG50Game.Ig50DudePlayer"
}
