///////////////////////////////////////////////////////////////////////////////
// AWMenuStart.uc
// Copyright 2003 Running With Scissors, Inc.  All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////
class Ig50MenuStart extends AWMenuStart;

var string StartGameAW7;
var string StartGameWeekend;
var string StartGameMF;
var string StartGameOrig;

var ShellMenuChoice StartAW7;
var ShellMenuChoice StartMF;
var ShellMenuChoice StartWeekend;
var ShellMenuChoice StartOrig;

var string StartAW7Text;
var string StartMFText;
var string StartWeekendText;
var string StartOrigText;

var string StartAW7Help;
var string StartMFHelp;
var string StartWeekendHelp;
var string StartOrigHelp;

///////////////////////////////////////////////////////////////////////////////
// Create menu contents
///////////////////////////////////////////////////////////////////////////////
function CreateMenuContents()
	{
	Super(ShellMenuCW).CreateMenuContents();

	AddTitle(TitleText, F_FancyXL, TA_Left);

	ItemFont = F_FancyL;
	DifficultyCombo = AddComboBox(DifficultyText, DifficultyHelp, ItemFont);
	DifficultyCombo.List.MaxVisible = ArrayCount(P2GameInfoSingle(GetPlayerOwner().Level.Game).DifficultyNames);

	StartAW7 =		AddChoice(StartAW7Text,		StartAW7Help,		ItemFont,	TA_Left);
//	StartMF =		AddChoice(StartMFText,		StartMFHelp,		ItemFont,	TA_Left);
	StartWeekend =	AddChoice(StartWeekendText,	StartWeekendHelp,	ItemFont,	TA_Left);
	StartOrig =		AddChoice(StartOrigText,	StartOrigHelp,		ItemFont,	TA_Left);

	BackChoice =	AddChoice(BackText,   	"",				ItemFont,	TA_Left, true);

	LoadValues();
	}

///////////////////////////////////////////////////////////////////////////////
// Handle notifications from controls
///////////////////////////////////////////////////////////////////////////////
function Notify(UWindowDialogControl C, byte E)
	{
	local int val;

	Super(ShellMenuCW).Notify(C, E);
	switch(E)
		{
		case DE_Change:
			switch (C)
				{
				case DifficultyCombo:
					DiffChanged(bUpdate);
					break;
				}
			break;
		case DE_Click:
			switch (C)
				{
				case BackChoice:
					GoBack();
					break;
				case StartAW7:
					StartGameURL = StartGameAW7;
					StartGame();
					ShellRootWindow(Root).bLaunchedMultiplayer = false;
					break;
//				case StartMF:
//					StartGameURL = StartGameMF;
//					StartGame();
//					ShellRootWindow(Root).bLaunchedMultiplayer = false;
//					break;
				case StartWeekend:
					StartGameURL = StartGameWeekend;
					StartGame();
					ShellRootWindow(Root).bLaunchedMultiplayer = false;
					break;
				case StartOrig:
					StartGameURL = StartGameOrig;
					StartGame();
					ShellRootWindow(Root).bLaunchedMultiplayer = false;
					break;
				}
			break;
		}
}

defaultproperties
{
     StartGameAW7="AW7_intro.fuk?Game=AW7addinIG50Game.Ig50GameInfo"
     StartGameWeekend="AW7_WeekendIntro.fuk?Game=AW7addinIG50Game.Ig50GameWeekend"
     StartGameOrig="MovieIntro.fuk?Game=AWWrapGame.AWGameSPFinal"
     StartAW7Text="AW7 Start"
     StartMFText="M-F Start"
     StartWeekendText="Weekend Start"
     StartOrigText="Original AW Start"
     StartAW7Help="Play all seven days"
     StartMFHelp="Play Monday through Friday only"
     StartWeekendHelp="Play Weekend only"
     StartOrigHelp="Play original AW game (no AW7)"
     ItemSpacingY=10.000000
     astrTextureDetailNames(0)="UltraLow"
     astrTextureDetailNames(1)="Low"
     astrTextureDetailNames(2)="Medium"
     astrTextureDetailNames(3)="High"
}
